<style>
  .input-tip {
    font-family: open_sans;
    width: 90vw;
    font-size: 12px;
    color: #717170;
    margin: 0;
  }

  .text-input {
    padding: 8px;
    margin-top: 4px;
    background-color: white;
    background: #ffffff;
    border-radius: 8px;
    border: 1px solid #717170;
    width: 100%;
    box-sizing: border-box;
    display: block;
  }

  .hidden {
    display: none !important;
  }

  .form-error {
    color: #e71316;
    font-family: open_sans;
    font-size: 12px;
    line-height: 16px;
    letter-spacing: 0.466667px;
    margin-top: 3px;
    margin-bottom: 0px;
  }

  .text-input-error {
    background: rgba(231, 19, 22, 0.2);
    border: 1px solid #E71316;
    border-radius: 8px;
  }

  button:disabled {
    color: rgba(0, 0, 0, 0.26);
    background-color: rgba(0, 0, 0, 0.12);
  }

  .error-text {
    font-size: 14px;
    font-style: normal;
    line-height: 19px;
    font-stretch: normal;
    letter-spacing: normal;
    color: #e71316;
    padding-bottom: 14px;
  }

  .reset {
    padding: 16px;
    height: auto;
  }

  .top-padded {
    padding-top: 10px;
  }
</style>

<div class="reset">
    <div id="errors" class="error-text"></div>

    <form method="post" action="{{ base_path }}/reset_password">
      <input name="reset_code" type="hidden" value="{{ reset_code }}">
      <input name="_csrf" type="hidden" value="{{ csrf_token }}">
      <!-- Password -->
      <div>
          <label for="password" class="register-field-labels">Create Password</label>
          <p class="input-tip" id="password-requirements">
            7+ characters, at least 1 lowercase letter, 1 uppercase letter, 1 number and 1 special character
          </p>
          <input type="password" id="password" name="password" class="text-input" autocomplete="new-password" required />
          <p class="input-tip form-error hidden" id="password-error"></p>
        </div>
      <!-- Password Confirmation -->
      <div class="top-padded">
          <label for="password_confirmation" class="register-field-labels">Confirm Password</label>
          <input name="password_confirmation" id="confirm-password" required type="password" autocomplete="new-password" class="text-input" />
        </div>
      <p class="input-tip form-error hidden" id="password-confirmation-error"></p>
      <button id="reset" class="primary-button" disabled>
        Reset
      </button>
      </div>
    </form>
</div>

<script>
  const form = document.querySelector('form');
  const passwordField = document.getElementById('password');
  const passwordConfirmationField = document.getElementById('confirm-password');
  const resetButton = document.getElementById('reset');

  const password = form.querySelector('[name="password"]');
  const passwordConfirmation = form.querySelector('[name="password_confirmation"]');

  password.addEventListener('blur', () => didUpdatePassword(password.value));
  passwordConfirmation.addEventListener('blur', () => didUpdatePasswordConfirmation(password.value, passwordConfirmation.value));

  password.addEventListener('input', () => isReadyToSubmit(password.value, passwordConfirmation.value));
  passwordConfirmation.addEventListener('input', () => isReadyToSubmit(password.value, passwordConfirmation.value));

  const errorDiv = document.querySelector("#errors");

  function isValidPassword(passwordValue) {
    // 1+ number, 1+ lowercase, 1+ uppercase, 1+ symbol, 7+ characters - no spaces
    const passwordRegex = /^(?!.*\s)(?=.*[0-9])(?=.*[a-z])(?=.*[A-Z])(?=.*[*@!#$%^&+=~{}]).{7,}/;
    return passwordRegex.test(passwordValue);
  }

  function didUpdatePassword(passwordValue) {
    errorDiv.classList.add('hidden');
    const passwordError = document.getElementById('password-error');
    if (isValidPassword(passwordValue)) {
      passwordField.classList.remove('text-input-error');
      passwordError.classList.add('hidden');
      return;
    } else if (passwordValue.length === 0) {
      passwordError.innerText = "Please create your password";
    } else {
      passwordError.innerText = "Must contain at least 1 lowercase and 1 uppercase letter, 1 special character, and be at least 7 characters long"
    }
    passwordField.classList.add('text-input-error');
    passwordError.classList.remove('hidden');
  }

  function didUpdatePasswordConfirmation(passwordValue, passwordConfirmationValue) {
    errorDiv.classList.add('hidden');
    const passwordConfirmationError = document.getElementById('password-confirmation-error');
    const passwordsMatch = passwordValue === passwordConfirmationValue;
    if (passwordConfirmationValue.length === 0) {
      passwordConfirmationError.innerText = "Please confirm your password"
    } else if (passwordsMatch) {
      passwordConfirmationField.classList.remove('text-input-error');
      passwordConfirmationError.classList.add('hidden');
      return;
    } else {
      passwordConfirmationError.innerText = "Passwords entries must match"
    }
    passwordConfirmationField.classList.add('text-input-error');
    passwordConfirmationError.classList.remove('hidden');
  }

  function isReadyToSubmit(passwordValue, passwordConfirmationValue) {
    if(passwordValue === passwordConfirmationValue && isValidPassword(passwordValue)) {
      resetButton.disabled = false;
    } else {
      resetButton.disabled = true;
    }
  }

  if (window.parent && window.location.pathname.includes('reset_password')) {
      window.parent.postMessage({ type: "idp-reset-password-initialized" }, "*")
  }

  function passwordInUse() {
      const span = document.createElement("span");

      span.innerText = "Password currently in use. Please provide a new password.";

      errorDiv.appendChild(span);

      passwordField.classList.add('text-input-error');
      passwordConfirmationField.classList.add('text-input-error');
  }

  function mismatchPassword() {
      const passwordConfirmationError = document.getElementById('password-confirmation-error');

      passwordConfirmationError.innerText = "Passwords entries must match"
      passwordConfirmationField.classList.add('text-input-error');
      passwordConfirmationError.classList.remove('hidden');
  }

  function invalidPassword() {
      const passwordError = document.getElementById('password-error');

      passwordError.innerText = "Must contain at least 1 lowercase and 1 uppercase letter, 1 special character, and be at least 7 characters long"
      passwordField.classList.add('text-input-error');
      passwordError.classList.remove('hidden');
  }

  function missingPassword() {
      const passwordError = document.getElementById('password-error');
      const passwordConfirmationError = document.getElementById('password-confirmation-error');

      passwordError.innerText = "Please create your password";
      passwordField.classList.add('text-input-error');
      passwordError.classList.remove('hidden');

      passwordConfirmationError.innerText = "Please confirm your password"
      passwordConfirmationField.classList.add('text-input-error');
      passwordConfirmationError.classList.remove('hidden');
  }

  if (typeof ERRORS !== "undefined") {
      const error = ERRORS[0];
      switch (error) {
          case 'password_is_already_in_use':
              passwordInUse();
              break;
          case 'auth_mismatch_password':
              mismatchPassword();
              break;
          case 'auth_invalid_password':
              invalidPassword();
              break;
          case 'auth_missing_password':
              missingPassword();
              break;
      }
  }

</script>
